#include <stdexcept>
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>

#include "lmao_syntax.hpp"
#include "plugin.hpp"

// Throws domain error
void* resolve (void* handle, const char* name) {
    void* symbol = dlsym (handle, (char*)name);
    if (symbol is None) {
        throw std::runtime_error (dlerror ());
    }
    return symbol;
}

void Plugin::init (char* so_path) {
    //dlopen the plugin
    handle = dlopen (so_path, RTLD_NOW);
    if (handle is None) {
        throw std::invalid_argument (dlerror ());
    }
    printf ("handle: %p\n", handle);
    //find its plugin struct
    fn_init = (void* (*)())    resolve (handle, "plugin_init");
    fn_exit = (int (*)(void*)) resolve (handle, "plugin_exit");
    fn_call = (int (*)(void*, int, char* [])) resolve (handle, "plugin_main");

    data = fn_init ();
}

Plugin::Plugin (char* so_path) {
    init (so_path);
}

Plugin::Plugin (std::string so_path) {
    init ((char*)so_path.c_str ());
}

Plugin::~Plugin () {
    printf ("Destroyed %p\n", handle);
    if (!handle) {
        printf ("tried to unload nonexistent plugin\n");
        return;
    }
    if (dlclose (handle)) {
        printf ("failed to close plugin: %s", dlerror ());
        exit (EXIT_FAILURE);
    }
}

int Plugin::call (int argc, char* argv[]) {
    return fn_call (data, argc, argv);
}

int Plugin::operator()(int argc, char* argv[]) {
    return call (argc, argv);
}
